import { getTouchPoint, isPromise, isVerticalTouch } from '@/libs/util';
import { getRelativeOffset } from '@/libs/dom';
import animateScroll from '@/libs/animateScroll';
import scroll from '@/core/elements/scroller/scroll';
import STATUS from '@/core/elements/scroller/status';
import Pull from '@/core/elements/pull';
import PullHook from '@/core/elements/pull/pull-hook';

var style = {
  computed: {
    styles: function styles () {
      var styles = {};

      var scroller = {};
      var content = {};

      if (this.scrollY) {
        var contentPaddingBottom = 0;
        var height = Number(this.height);
        // let minHeight = ui.IS_IOS ? height + 0.5 : height

        scroller.height = height + 'px';

        if (this.enableReachBottomLoad) {
          contentPaddingBottom += 50;
        }

        content.paddingBottom = contentPaddingBottom ? contentPaddingBottom + 'px' : null;
        // content.minHeight = minHeight + 'px'
      } else if (this.scrollX) {
        scroller.width = this.width + 'px';
        scroller.height = this.height + 'px';
      }
      content = Object.assign({}, content, this.contentStyle);

      styles.scroller = scroller;
      styles.content = content;

      this.contentHeight = Number(this.height);

      return styles
    }
  }
};

var UiScrollView = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{ref:"container",staticClass:"ui-scroll-view",class:{ 'ui-scroll-view-x': _vm.scrollX, 'ui-scroll-view-y': _vm.scrollY },style:(_vm.styles.scroller)},[(_vm.status === _vm.STATUS.LOADING)?_vm._t("loading",[_vm._m(0)]):_vm._e(),_vm._v(" "),(_vm.status === _vm.STATUS.ERROR)?_vm._t("retry",[_c('div',{staticClass:"retry"},[_vm._v("轻触重试...")])]):_vm._e(),_vm._v(" "),_c('div',{directives:[{name:"show",rawName:"v-show",value:(_vm.status === _vm.STATUS.SUCCESS),expression:"status === STATUS.SUCCESS"}],ref:"content",staticClass:"ui-scroll-view-content",style:(_vm.styles.content)},[(_vm.pullDown)?_vm._t("pull-down",[_c('pull-hook',{attrs:{"pull-style":"ios","state":_vm.pullState,"type":"pull-down"}})]):_vm._e(),_vm._v(" "),_vm._t("default"),_vm._v(" "),(_vm.pullUp)?_vm._t("pull-up",[_c('pull-hook',{attrs:{"pull-style":"ios","state":_vm.pullState,"type":"pull-up"}})]):_vm._e(),_vm._v(" "),(_vm.pullRight)?_vm._t("pull-right"):_vm._e(),_vm._v(" "),(_vm.pullLeft)?_vm._t("pull-left"):_vm._e(),_vm._v(" "),(_vm.enableReachBottomLoad && _vm.showLoadMore)?_vm._t("load-more",[_vm._m(1)]):_vm._e()],2)],2)},staticRenderFns: [function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"loading-content"},[_c('div',{staticClass:"loading"}),_vm._v(" "),_c('span',{staticClass:"loading-text"},[_vm._v("加载中...")])])},function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"load-more-content"},[_c('div',{staticClass:"load-more-icon loading"}),_vm._v(" "),_c('span',[_vm._v("正在加载...")])])}],
  name: 'UiScrollView',
  mixins: [style, scroll],
  props: {
    enablePullLeft: Boolean,
    enableReachBottomLoad: Boolean,
    // 滚动到底加载触发距离
    reachBottomLoadDistance: {
      type: Number,
      default: 0
    },
    pullDown: Object,
    pullUp: Object,
    pullLeft: Object,
    pullRight: Object,
    onLoadMore: {
      type: Function,
      default: function () {}
    },
    // scroller加载
    load: {
      type: Object
    },
    // 垂直滚动位置
    scrollTop: {
      type: [Number, String],
      default: 0
    },
    // 水平滚动位置
    scrollLeft: {
      type: [Number, String],
      default: 0
    },
    // 滚动到指定el或指定id
    scrollIntoView: {
      type: [HTMLElement, String]
    },
    scrollWithAnimation: {
      type: Boolean,
      default: true
    },
    scrollSpeed: {
      type: Number,
      default: 500
    },
    // 高度
    height: {
      type: [Number, String]
    },
    // 宽度
    width: {
      type: [Number, String],
      default: window.innerWidth
    },
    // 内容样式
    contentStyle: Object,
    // 是否启用回到顶部功能
    enableBackToTop: {
      type: Boolean,
      default: true
    },
    // 水平滚动
    scrollX: Boolean,
    // 垂直滚动
    scrollY: Boolean,
    // 是否阻止touch事件冒泡
    touchStopPropagation: Boolean,
    // scroll事件触发类型
    probe: {
      type: [Number, String]
    }
  },
  components: {
    PullHook: PullHook
  },
  data: function data () {
    return {
      // 是否初始化完成
      isInit: false,
      // pull状态
      pullState: 0,
      // 到容器顶部的距离
      selfScrollTop: this.scrollTop,
      // 到容器左侧的距离
      selfScrollLeft: this.scrollLeft,
      // 当前滚动位置
      scrollPosition: 0,
      // 是否显示“加载更多”
      showLoadMore: false,
      // 内容高度
      contentHeight: 0,
      // 滚动状态
      scrollState: 0,
      // 是否显示自定义nav-bar（用于tab-bar切换时）
      showCustomNavBar: true,
      // 检测scrollend的定时器
      scrollEndTimeout: null,
      // 检测scrollend的时间
      scrollEndDelay: 100,
      // 是否为dialog页面
      isDialog: false,
      // div滚动
      scrollType: 'div',
      // scroller加载状态，结合load使用
      STATUS: STATUS,
      status: STATUS.LOADING,
      // 水平滚动时为scrollLet，垂直滚动时为scrollTop
      scrollAttr: '',
      selfProbe: Number(this.probe),
      // 是否外部改变scrollTop或scrollLeft
      outerChangeScrollPosition: false,
      // 是否外部改变ScrollIntoView
      outerChangeScrollIntoView: false
    }
  },
  watch: {
    scrollTop: function scrollTop (val) {
      this.selfScrollTop = val;
      this.scrollPosition = val;
      this.outerChangeScrollPosition = true;
      if (val >= 0) {
        this.scrollTo(val);
      }
    },
    scrollPosition: function scrollPosition (val) {
      if (this.container && this.scrollY) {
        var totalDistance = val + window.innerHeight + this.reachBottomLoadDistance;
        var height = this.container.scrollHeight;

        this.showLoadMore = totalDistance >= height;
      }
    },
    scrollLeft: function scrollLeft (val) {
      this.selfScrollLeft = val;
      this.scrollPosition = val;
      this.outerChangeScrollPosition = true;
      if (val < 0) {
        val = 0;
      }
      this.scrollTo(val);
    },
    scrollIntoView: function scrollIntoView (val) {
      this.outerChangeScrollIntoView = true;
      this.handleScrollIntoView();
    },
    outerChangeScrollPosition: function outerChangeScrollPosition (val) {
      var this$1 = this;

      if (val) {
        window.setTimeout(function () {
          this$1.outerChangeScrollPosition = false;
        }, 600);
      }
    },
    outerChangeScrollIntoView: function outerChangeScrollIntoView (val) {
      var this$1 = this;

      if (val) {
        window.setTimeout(function () {
          this$1.outerChangeScrollIntoView = false;
        }, 600);
      }
    },
    showLoadMore: function showLoadMore (val) {
      if (val && this.enableReachBottomLoad) {
        this.onLoadMore();
      }
    }
  },
  mounted: function mounted () {
    var this$1 = this;

    this.container = this.$refs.container;
    this.transformContainer = this.$refs.content;

    if (this.scrollY) {
      this.scrollAttr = 'scrollTop';
      this.scrollPosition = this.selfScrollTop;
    } else if (this.scrollX) {
      this.scrollAttr = 'scrollLeft';
      this.scrollPosition = this.selfScrollLeft;
    }

    this.initPull();
    this.handleTouchStopPropagation();

    if (this.scrollPosition) {
      this.outerChangeScrollPosition = true;
    }

    this.handleInnerScrollEnd = function () {
      this$1.$emit('update:scrollIntoView', null);
    };

    this.handleLoad()
        .then(function () {
          this$1.bindScroll();
          // 使用$nextTick，避免初始化时执行activated的逻辑
          this$1.$nextTick(function () {
            this$1.isInit = true;
            this$1.handleScrollTo();
            this$1.handleScrollIntoView();
          });
        });
  },
  methods: {
    initPull: function initPull () {
      var this$1 = this;

      var options = {};

      var pullNames = ['pullDown', 'pullUp', 'pullLeft', 'pullRight'];

      pullNames.forEach(function (name) {
        if (this$1[name]) {
          options[name] = Object.assign({}, {onStateChange: this$1.handlePullStateChange}, this$1[name]);

          this$1.$watch(name, function (val) {
            this$1.pull.options[name] = val;
          });
        }
      });

      if (Object.keys(options).length > 0) {
        options.outerEl = this.container;
        options.innerEl = this.transformContainer;
        this.pull = new Pull(options);
      }
    },
    handleTouchStopPropagation: function handleTouchStopPropagation () {
      var this$1 = this;

      if (this.touchStopPropagation) {
        var el = this.container;

        el.addEventListener('touchstart', function (e) {
          this$1.startPoint = getTouchPoint(e);
        });

        el.addEventListener('touchmove', function (e) {
          this$1.endPoint = getTouchPoint(e);
          if (isVerticalTouch(this$1.startPoint, this$1.endPoint)) {
            this$1.scrollY && e.stopPropagation();
          } else {
            this$1.scrollX && e.stopPropagation();
          }
        });
      }
    },
    handlePullStateChange: function handlePullStateChange (state) {
      this.pullState = state;
    },
    /**
     * 处理页面加载
     * 1. load.handle为Promise函数，则显示loading状态
     * 2. 其他情况为加载成功
     */
    handleLoad: function handleLoad () {
      var this$1 = this;

      var promise = null;

      if (!this.load ||
        !this.load.handle ||
        !isPromise(promise = this.load.handle())) {
        this.status = STATUS.SUCCESS;
        return Promise.resolve(promise)
      }

      this.status = STATUS.LOADING;

      promise
        .then(function (data) {
          this$1.status = STATUS.SUCCESS;
        })
        .catch(function () {
          this$1.status = STATUS.ERROR;
        });

      return promise
    },
    handleScrollTo: function handleScrollTo () {
      if (this.scrollPosition) {
        this.__scroll(this.scrollPosition);
      }
    },
    handleScrollIntoView: function handleScrollIntoView () {
      if (this.scrollIntoView) {
        var target;
        if (this.scrollIntoView instanceof HTMLElement) {
          target = this.scrollIntoView;
        } else if (typeof this.scrollIntoView === 'string') {
          target = this.$el.querySelector('#' + this.scrollIntoView);
        }
        if (target) {
          var scrollTop = getRelativeOffset(target, this.$el)[this.scrollAttr];

          animateScroll({
            el: this.$el,
            scrollAttr: this.scrollAttr,
            scrollTarget: scrollTop,
            speed: this.scrollWithAnimation ? this.scrollSpeed : 0
          });
        }
      }
    }
  }
};

var change = function (old) {
    // let roldstr = JSON.stringify(old)
    // let rold = JSON.parse(roldstr)

    var array = [];
    var data = {};
    var wating = {};
    var BEFORE = 'id';
    old.forEach(function (ele) {
        var element = {};
        element.name = ele.name;
        element.value = ele.value;
        if (ele.parent) {
            element.parent = ele.parent;
        }
        var value = element.value;
        data[("" + BEFORE + value)] = element;
        var parent = element.parent;
        var watingEls = wating[("" + BEFORE + value)];
        if(watingEls) {
            element.children = watingEls;
        }
        if(!parent) {
            array.push(element);
        } else {
            var parentEl = data[("" + BEFORE + parent)];
            if(parentEl) {
                if(!parentEl.children) {
                    parentEl.children = [];
                }
                parentEl.children.push(element);
            } else {
                if(!wating[("" + BEFORE + parent)]) {
                    wating[("" + BEFORE + parent)] = [];
                }
                wating[("" + BEFORE + parent)].push(element);
            }
        }
    });

    return array
};

var index = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"ui-cascader",style:([_vm.cascaderStyleObj])},[(_vm.showTitle)?_c('div',{staticClass:"cascader-name-wrap"},_vm._l((_vm.seqData),function(seqItem,seqIndex){return _c('div',{key:seqIndex,staticClass:"cascader-name-item-wrap",class:{ 'cascader-name-item-wrap-clicked' :seqItem.selected, },style:({
        color: seqItem.selected ? _vm.themeColor: '',
        'border-bottom': seqItem.selected ? ("1px solid " + (_vm.themeColor)) : '',
      }),on:{"tap":function($event){_vm.seqItemTapHandler(seqIndex);}}},[_vm._v(" "+_vm._s(seqItem[_vm.nameKey])+" ")])})):_vm._e(),_vm._v(" "),_c('div',{staticClass:"cascader-content-div",style:({
      width: ((_vm.width) + "px"),
      height: ((_vm.height-this.titleMargin) + "px"),
      overflow:'hidden'
    })},[_c('div',{staticClass:"cascader-content-wrap",style:([_vm.cascaderContentWrapStyleObj])},_vm._l((_vm.newArray),function(blockItem,blockIndex){return _c('div',{key:blockIndex,staticClass:"cascader-block",style:([_vm.cascaderBlockStyleObj])},_vm._l((blockItem),function(item,index){return _c('div',{key:index,staticClass:"cascader-block-item",on:{"tap":function($event){_vm.itemTapHandler(item, index);}}},[_c('div',{staticClass:"cascader-item",class:{ 'cascader-item-clicked' : item.selected, 'cascader-item-border': _vm.border },style:({
              color: item.selected ? _vm.themeColor : ''
            })},[_vm._v(" "+_vm._s(item[_vm.nameKey])+" ")])])}))}))])])},staticRenderFns: [],
  config: {
    usingComponents: {
      UiScrollView: UiScrollView
    }
  },
  components: {
    UiScrollView: UiScrollView
  },
  created: function created () {
    this.seqData = [{
      name: this.title ? this.title :this.$t('ui.cascader.select'),
      selected: true}];

    this.titleMargin = this.showTitle ? 50 : 0;
    this.selfHeight = Number(this.height);
    this.selfWidth = Number(this.width);
    if (!this.isTree) {
      this.selfData = change(this.data);
    } else {
      this.selfData = [].concat( this.data );
    }

  },
  watch: {
    value: function value (val) {
      var this$1 = this;

      this.newArray = [];
      this.newArray.push([]);
      this.selfData.forEach(function (element) {
        element.deep = this$1.step;
        this$1.newArray[0].push(element);
      });
      if (val.length) {
        for (var i = 0; i < val.length; i++) {
          for (var j = 0; this.newArray[i] && j < this.newArray[i].length; j++) {
            if (this$1.newArray[i][j].value) {
              if (this$1.newArray[i][j].value === val[i].value) {
                val[i].deep = i;
                this$1.itemTapHandler(val[i], j);
                break
              }
            } else {
              if (this$1.newArray[i][j].name === val[i].name) {
                val[i].deep = i;
                this$1.itemTapHandler(val[i], j);
                break
              }
            }
          }
        }
      }

    }
  },
  mounted: function mounted () {
    var this$1 = this;

    this.newArray.push([]);
    this.selfData.forEach(function (element) {
      element.deep = this$1.step;
      this$1.newArray[0].push(element);
    });

    var res = this.$el.getBoundingClientRect();
    this.dynamicWidth = this.selfWidth / 2;
    this.blockWidth = this.dynamicWidth;
    if (this.value.length) {
      for (var i = 0; i < this.value.length; i++) {
        for (var j = 0; this.newArray[i] && j < this.newArray[i].length; j++) {
          if (this$1.newArray[i][j].value) {
            if (this$1.newArray[i][j].value === this$1.value[i].value) {
              this$1.value[i].deep = i;
              this$1.itemTapHandler(this$1.value[i], j);
              break
            }
          } else {
            if (this$1.newArray[i][j].name === this$1.value[i].name) {
              this$1.value[i].deep = i;
              this$1.itemTapHandler(this$1.value[i], j);
              break
            }
          }
        }
      }
    }

      // this.setData({
      //   cascaderContentWrapStyle: OTS(this.cascaderContentWrapStyleObj()),
      //   cascaderBlockStyle: OTS(this.cascaderBlockStyleObj())
      // })
  },

  mixins: [ ],
  props: {
    data: {
      type: Array,
    },
    width: {
      type: [Number, String],
      default: ui.WIN_WIDTH
    },
    height: {
      type: [Number, String],
      default: 300
    },
    themeColor: {
      type: String,
      default: ''
    },
    showTitle: {
      type: Boolean,
      default: true
    },
    title: String,
    nameKey: {
      type: String,
      default: 'name'
    },
    valueKey: {
      type: String,
      default: 'value'
    },
    border: {
      type: Boolean,
      default: true
    },
    value: {
      type: Array,
      default: function default$1$$1 () {
        return []
      }
    },
    isTree: {
      type: Boolean,
      default: true
    }
  },
  data: function data () {
    return {
      newArray: [],
      step: 0,
      dynamicWidth: 0,
      selfData: [],
      selectseqIndex: 0,
      seqData: [],
      transmode: ''
    }
  },
  computed: {
    cascaderBlockStyleObj: function cascaderBlockStyleObj () {
      var style = {};
      style.width = this.blockWidth + 'px';
      style.height = this.selfHeight - this.titleMargin + 'px';
      return style
    },
    cascaderContentWrapStyleObj: function cascaderContentWrapStyleObj () {
      var style = {};
      var trans;
      if (this.showTitle) {
        style.height = this.selfHeight - this.titleMargin + 'px';
      } else {
        style.height = this.selfHeight + 'px';
      }
      if (this.transmode === 'showtrans') {
        if (this.selectseqIndex !== this.seqData.length - 1) {
          trans = -this.selectseqIndex * this.blockWidth;
        } else {
          trans = (-this.selectseqIndex + 1) * this.blockWidth;
        }
      } else {
        if (this.step > 1) {
        trans = -(this.step - 1) * this.blockWidth;
        } else {
          trans = 0;
        }
      }
      style.transform = "translate3d(" + trans + "px, 0, 0)";
      style.width = this.dynamicWidth + 'px';
      return style
    },
    cascaderStyleObj: function cascaderStyleObj () {
      var style = {};
      if (('' + this.selfWidth).indexOf('%') > -1) {
        style.width = this.selfWidth;
      } else {
        style.width = this.selfWidth + 'px';
      }
      style.height = this.selfHeight + 'px';
      return style
    }
  },
  methods: {
    nextStep: function nextStep (item, index, tbmode) {
      var this$1 = this;

      console.log(item);
      var selectIndex = index;
      this.step++;
      this.newArray.push([]);
      if (!this.newArray[this.step - 1][selectIndex].children) { // 点击最后的一项
        this.seqData.forEach (function (element) {
          element.selected = false;
        });
        this.newArray[this.step - 1].forEach (function (element) {
          element.selected = false;
        });
        this.newArray[this.step - 1][selectIndex].selected = true;
        this.step--;
        this.seqData.splice(-1, 1, {
          value: item.value,
          name: item.name,
          selected: true
        });
        this.emitValue();
        return
      }
      //添加轨迹词语
      if (!tbmode) {
        this.seqData.splice(-1, 0, {
          name: item.name,
          value: item.value
        });
        this.seqData[this.seqData.length - 1].name = this.title ? this.title:this.$t('ui.cascader.select');
      } else {
        this.seqData.splice(-1, 0, {name: item.name,
          value: item.value});
        this.seqData.forEach (function (element) {
          element.selected = false;
        });
        this.seqData[this.seqData.length - 1].name = this.title ? this.title:this.$t('ui.cascader.select');
        this.seqData[this.seqData.length - 1].selected = true;
      }

      // 更新宽及其transfrom

      this.dynamicWidth = (item.deep + 2) * this.blockWidth;
      // this.setData({
      //   cascaderContentWrapStyle: OTS(this.cascaderContentWrapStyleObj()),
      // })

      // 换颜色

      this.newArray[this.step - 1].forEach(function (element) {
        element.selected = false;
      });
      this.newArray[this.step - 1][selectIndex].selected = true;
      // console.dir(this.newArray[this.step - 1][selectIndex].children)

      var children = this.newArray[this.step - 1][selectIndex].children;

      for (var i = 0; i < children.length; i++) {
        children[i].deep = this$1.step;
        children[i].selected = false;
        this$1.newArray[this$1.step].push(children[i]);
      }
      this.$forceUpdate();
    },
    turnBackStep: function turnBackStep (item, index) {
      var selectBlock = item.deep;
      this.newArray = this.newArray.slice(0, selectBlock + 1);
      this.step = selectBlock;
      // 退回到某数组
      this.seqData.splice(this.step, this.seqData.length - this.step - 1);
      this.nextStep(item, index, true);
    },
    emitValue: function emitValue () {
      var this$1 = this;

      var send = [];
      this.seqData.forEach(function (element) {
        var obj = {};
        obj[this$1.nameKey] = element[this$1.nameKey];
        obj[this$1.valueKey] = element[this$1.valueKey];
        send.push(obj);
      });
      this.$emit('selected', send);
      console.log(send);
    },
    itemTapHandler: function itemTapHandler (item, index) {
      this.transmode = 'addtrans';
      if (item.deep < this.step) {
        this.turnBackStep(item, index);
      } else {
        this.nextStep(item, index);
      }
    },
    seqItemTapHandler: function seqItemTapHandler (seqIndex) {
      this.selectseqIndex = seqIndex;
      this.seqData.forEach(function (element) {
        element.selected = false;
      });
      this.seqData[seqIndex].selected = true;

      if (this.step !== seqIndex) {

        this.transmode = 'showtrans';
        this.$forceUpdate();
      } else {

      }
    }
  }
};

export default index;
