import PickerView from '@/components/picker-view/picker-view';
import Cell from '@/components/cell';
import Popup from '@/components/popup';
import InlineDesc from '@/components/inline-desc';
import Flexbox from '@/components/flexbox';
import FlexboxItem from '@/components/flexbox-item';
import array2string from '@/filters/array2String';
import value2name from '@/filters/value2name';
import uuidMixin from '@/libs/mixin_uuid';
import TransferDom from '@/directives/transfer-dom';
import fecha from '@/libs/fecha';
import name2value from '@/filters/name2value';

var getObject = function (obj) {
  return JSON.parse(JSON.stringify(obj))
};

var Picker = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"ui-cell-box"},[_c('div',{directives:[{name:"show",rawName:"v-show",value:(_vm.showCell),expression:"showCell"}],staticClass:"weui-cell ui-tap-active weui-cell_access",on:{"click":_vm.onClick}},[_c('div',{staticClass:"weui-cell__hd"},[(_vm.title)?_c('span',{staticClass:"weui-label",style:(_vm.labelStyles),domProps:{"innerHTML":_vm._s(_vm.title)}}):_vm._e()]),_vm._v(" "),_c('div',{staticClass:"ui-cell-primary ui-picker-select-box"},[_c('div',{staticClass:"ui-picker-select",style:({textAlign: _vm.valueTextAlign})},[(!_vm.displayFormat && !_vm.rangeKey && _vm.value.length)?_c('span',{staticClass:"ui-popup-picker-value"},[_vm._v(_vm._s(_vm._f("array2string")(_vm.value)))]):_vm._e(),_vm._v(" "),(!_vm.displayFormat && _vm.rangeKey && _vm.value.length)?_c('span',{staticClass:"ui-popup-picker-value"},[_vm._v(_vm._s(_vm._f("value2name")(_vm.value,_vm.range, _vm.delimiter, _vm.rangeKey)))]):_vm._e(),_vm._v(" "),(_vm.displayFormat && _vm.value.length)?_c('span',{staticClass:"ui-popup-picker-value"},[_vm._v(_vm._s(_vm.displayFormat(_vm.value, _vm.value2name(_vm.value, _vm.range))))]):_vm._e(),_vm._v(" "),(!_vm.value.length && _vm.placeholder)?_c('span',{staticClass:"ui-picker-placeholder",domProps:{"textContent":_vm._s(_vm.placeholder)}}):_vm._e()])]),_vm._v(" "),_c('div',{staticClass:"weui-cell__ft"})]),_vm._v(" "),(!_vm.disabled)?_c('popup',{staticClass:"ui-popup-picker",attrs:{"id":("ui-popup-picker-" + (_vm.uuid))},on:{"hide":_vm.onPopupHide,"show":_vm.onPopupShow},model:{value:(_vm.showValue),callback:function ($$v) {_vm.showValue=$$v;},expression:"showValue"}},[_c('div',{staticClass:"ui-popup-picker-container"},[_c('div',{staticClass:"ui-picker-header",on:{"touchmove":function($event){$event.preventDefault();}}},[_c('flexbox',[_c('flexbox-item',{staticClass:"ui-picker-header-menu ui-picker-cancel",nativeOn:{"click":function($event){_vm.onAction(false);}}},[_vm._v(_vm._s(_vm.$t('ui.picker.cancel_text')))]),_vm._v(" "),_c('flexbox-item',{staticClass:"ui-picker-header-menu ui-picker-confirm",class:{ disabled: !_vm.canConfirm },nativeOn:{"click":function($event){_vm.onAction(true);}}},[_vm._v(_vm._s(_vm.$t('ui.picker.confirm_text')))])],1)],1),_vm._v(" "),_c('picker-view',{attrs:{"data":_vm.range,"columns":_vm.columns,"fixed-columns":_vm.fixedColumns,"range-key":_vm.rangeKey,"container":'#ui-popup-picker-'+_vm.uuid,"column-width":_vm.columnWidth},on:{"on-start":_vm.onPickerStart,"on-end":_vm.onPickerEnd,"on-change":_vm.onPickerChange},model:{value:(_vm.tempValue),callback:function ($$v) {_vm.tempValue=$$v;},expression:"tempValue"}})],1)]):_vm._e()],1)},staticRenderFns: [],
  directives: {
    TransferDom: TransferDom
  },
  created: function created () {
    if (typeof this.show !== 'undefined') {
      this.showValue = this.show;
    }
  },
  mixins: [uuidMixin],
  components: {
    PickerView: PickerView,
    Cell: Cell,
    Popup: Popup,
    Flexbox: Flexbox,
    FlexboxItem: FlexboxItem,
    InlineDesc: InlineDesc
  },
  filters: {
    array2string: array2string,
    value2name: value2name
  },
  props: {
    range: {
      type: Array,
      default: Array
    },
    rangeKey: {
      type: String
    },
    value: {
      type: [Number, String, Array]
    },
    valueTextAlign: {
      type: String,
      default: 'right'
    },
    title: String,
    cancelText: String,
    confirmText: String,
    placeholder: String,
    columns: {
      type: Number,
      default: 0
    },
    fixedColumns: {
      type: Number,
      default: 0
    },
    showName: Boolean,
    inlineDesc: [String, Number, Array, Object, Boolean],
    showCell: {
      type: Boolean,
      default: true
    },
    show: Boolean,
    displayFormat: Function,
    isTransferDom: {
      type: Boolean,
      default: true
    },
    columnWidth: Array,
    delimiter: {
      type: String,
      default: ' '
    },
    disabled: Boolean
  },
  computed: {
    labelStyles: function labelStyles () {
      return {
        display: 'block',
        width: this.$parent.labelWidth || this.$parent.$parent.labelWidth,
        textAlign: this.$parent.labelAlign || this.$parent.$parent.labelAlign,
        marginRight: this.$parent.labelMarginRight || this.$parent.$parent.labelMarginRight
      }
    }
  },
  methods: {
    value2name: value2name,
    getNameValues: function getNameValues () {
      return value2name(this.currentValue, this.range)
    },
    onClick: function onClick () {
      this.showValue = true;
    },
    onAction: function onAction (type) {
      if (this.canConfirm) {
        this.showValue = false;
        if (type) {
          var oldVal = this.currentValue;
          var newVal = getObject(this.tempValue);

          if (JSON.stringify(oldVal) !== JSON.stringify(newVal)) {
            this.$emit('on-change', newVal);
          }

          this.closeType = true;
          this.currentValue = newVal;
        } else {
          this.closeType = false;
          if (this.value.length > 0) {
            this.tempValue = getObject(this.currentValue);
          }
        }
      }
    },
    onPopupShow: function onPopupShow () {
      // reset close type to false
      this.closeType = false;
      this.$emit('show');
    },
    onPopupHide: function onPopupHide (val) {
      if (this.value.length > 0) {
        this.tempValue = getObject(this.currentValue);
      }
      if (!this.closeType) {
        this.$emit('cancel');
      }
    },
    onPickerStart: function onPickerStart () {
      this.canConfirm = false;
    },
    onPickerEnd: function onPickerEnd () {
      this.canConfirm = true;
    },
    onPickerChange: function onPickerChange (val) {
      this.canConfirm = true;

      if (JSON.stringify(this.currentValue) !== JSON.stringify(val)) {
        // if has value, replace it
        if (this.value.length) {
          var nowData = JSON.stringify(this.range);
          if (nowData !== this.currentData && this.currentData !== '[]') {
            this.tempValue = getObject(val);
          }
          this.currentData = nowData;
        } else { // if no value, stay quiet
          // if set to auto update, do update the value
        }
      }
      // TODO: bindcolumnchange
      this.$emit('on-shadow-change', getObject(val));
    }
  },
  watch: {
    value: function value (val) {
      if (JSON.stringify(val) !== JSON.stringify(this.tempValue)) {
        this.tempValue = getObject(val);
      }
    },
    currentValue: function currentValue (val) {
      this.$emit('input', getObject(val));
    },
    show: function show (val) {
      this.showValue = val;
    }
  },
  data: function data () {
    return {
      onShowProcess: false,
      tempValue: getObject(this.value),
      closeType: false,
      currentData: JSON.stringify(this.range), // used for detecting if it is after data change
      showValue: false,
      currentValue: this.value,
      canConfirm: true
    }
  }
};

var selector = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('picker',{attrs:{"title":_vm.title,"range":_vm.selfRange,"range-key":_vm.rangeKey,"disabled":_vm.disabled},on:{"on-change":_vm.onChange,"cancel":_vm.handleChancel},model:{value:(_vm.selfValue),callback:function ($$v) {_vm.selfValue=$$v;},expression:"selfValue"}},[_vm._v("> ")])},staticRenderFns: [],
  props: {
    range: {
      type: Array,
      default: Array
    },
    rangeKey: {
      type: String
    },
    title: {
      type: String,
      default: '当前选择'
    },
    value: {
      type: [Number]
    },
    disabled: Boolean
  },
  components: {
    picker: Picker
  },
  data: function data () {
    return {
      selfRange: [this.range],
      selfValue: [this.getSelfValue()],
      values: []
    }
  },
  created: function created () {
    this.setValues();
  },
  watch: {
    value: function value () {
      this.selfValue = [this.getSelfValue()];
    },
    range: function range () {
      if (Array.isArray(this.range)) {
        this.selfRange = [this.range];
        this.selfValue = [this.getSelfValue()];
        this.setValues();
      }
    }
  },
  methods: {
    setValues: function setValues () {
      if (typeof this.range[0] === 'object') {
        this.values = this.range.map(function (item) {
          return item.value
        });
      } else {
        this.values = this.range;
      }
    },
    getSelfValue: function getSelfValue () {
      if (typeof this.range[0] === 'object') {
        return this.range[this.value].value
      } else {
        return this.range[this.value]
      }
    },
    onChange: function onChange (val) {
      this.$emit('change', this.values.indexOf(val[0]));
    },
    handleChancel: function handleChancel () {
      this.$emit('cancel');
    }
  }
};

var multiSelector = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (_vm.isChain)?_c('picker',{attrs:{"title":_vm.title,"range":_vm.selfRange,"range-key":_vm.rangeKey,"columns":_vm.columns,"disabled":_vm.disabled,"show-name":""},on:{"on-change":_vm.onChange,"cancel":_vm.handleChancel},model:{value:(_vm.selfValue),callback:function ($$v) {_vm.selfValue=$$v;},expression:"selfValue"}}):_c('picker',{attrs:{"title":_vm.title,"range":_vm.selfRange,"range-key":_vm.rangeKey,"disabled":_vm.disabled},on:{"on-change":_vm.onChange,"cancel":_vm.handleChancel},model:{value:(_vm.selfValue),callback:function ($$v) {_vm.selfValue=$$v;},expression:"selfValue"}})},staticRenderFns: [],
  props: {
    range: {
      type: Array,
      default: Array
    },
    rangeKey: {
      type: String
    },
    title: {
      type: String,
      default: '当前选择'
    },
    value: {
      type: Array
    },
    isChain: Boolean,
    disabled: Boolean
  },
  components: {
    picker: Picker
  },
  data: function data () {
    return {
      selfRange: [],
      selfValue: [],
      columns: this.getColumns()
    }
  },
  watch: {
    value: function value () {
      this.selfValue = this.getSelfValue();
    },
    range: function range () {
      if (Array.isArray(this.range)) {
        this.selfRange = this.getSelfRange();
      }
    }
  },
  mounted: function mounted () {
    this.selfRange = this.getSelfRange();
    this.selfValue = this.getSelfValue();
  },
  methods: {
    getSelfRange: function getSelfRange () {
      if (this.isChain) {
        return this.flattenArray(this.range)
      } else {
        return this.range
      }
    },
    getSelfValue: function getSelfValue () {
      var this$1 = this;

      if (this.value) {
        if (this.isChain) {
          return this.value
        } else {
          var selfValue = [];
          for (var i = 0; i < this.value.length; i++) {
            selfValue.push(this$1.range[i][this$1.value[i]]);
          }
          return selfValue
        }
      } else {
        var selfValue$1 = [];
        if (this.isChain) {
          var start = this.range[0];
          selfValue$1.push(start.value);
          while (start.children) {
            start = start.children[0];
            selfValue$1.push(start.value);
          }
          return selfValue$1
        } else {
          selfValue$1 = this.range.map(function (item) {
            return item[0]
          });
        }

        return selfValue$1
      }
    },
    flattenArray: function flattenArray (array, parent) {
      var this$1 = this;

      var result = [];
      for (var i = 0; i < array.length; i++) {
        var obj = {};
        obj.value = array[i].value;
        obj[this$1.rangeKey] = array[i][this$1.rangeKey];
        if (parent) {
          obj.parent = parent;
        }
        result.push(obj);

        if (array[i].children) {
          result = result.concat(this$1.flattenArray(array[i].children, array[i].value));
        }
      }
      return result
    },
    // 在isChain模式下，需要知道columns值
    getColumns: function getColumns () {
      var columns = 1;
      var start = this.range[0];
      while (start.children) {
        columns++;
        start = start.children[0];
      }
      return columns
    },
    getValue: function getValue (val) {
      var this$1 = this;

      if (this.isChain) {
        return val
      } else {
        var value = [];
        for (var i = 0; i < val.length; i++) {
          value.push(this$1.range[i].indexOf(val[i]));
        }
        return value
      }
    },
    onChange: function onChange (val) {
      this.$emit('change', this.getValue(val));
    },
    handleChancel: function handleChancel () {
      this.$emit('cancel');
    }
  }
};

function padZero (num, len) {
  var zero = '';
  for (var i = 0; i < len - num.toString().length; i++) {
    zero += '0';
  }
  return zero + num
}

function padZeroForArray (arr, len) {
  return arr.map(function (item) {
    return padZero(item, len)
  })
}

var util = {
  // '2017-09-01' => new Date(2017, 8, 1)
  str2Date: function str2Date (str) {
    var arr = str.split('-');
    if (arr.length === 3) {
      return new Date(arr[0], Number(arr[1] - 1), arr[2])
    }
  },
  // new Date(2017, 8, 1) => ['2017', '09', '01']
  date2Arr: function date2Arr (date) {
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    var day = date.getDate();
    return padZeroForArray([year, month, day], 2)
  },
  // new Date(2017, 8, 1) => '2017-09-01'
  date2Str: function date2Str (date) {
    return this.date2Arr(date).join('-')
  },
  // '2017-09-01', { datepart: 'year', value: 1 } => '2018-09-01'
  dateStrAdd: function dateStrAdd (str, ref) {
    var datepart = ref.datepart;
    var value = ref.value;

    var date = this.str2Date(str);
    if (datepart === 'year') {
      date.setYear(date.getFullYear() + value);
    } else if (datepart === 'month') {
      date.setMonth(date.getMonth() + value);
    } else if (datepart === 'date') {
      date.setMonth(date.getDate() + value);
    }
    return this.date2Str(date)
  },
  generateTimeList: function generateTimeList (start, end) {
    var time = [];

    var startParts = start.split(':').map(function (p) { return Number(p); });
    var startHour = startParts[0];
    var startMinute = startParts[1];

    var endParts = end.split(':').map(function (p) { return Number(p); });
    var endHour = endParts[0];
    var endMinute = endParts[1];

    var hour = '';
    var minute = '';

    for (var i = startHour; i <= endHour; i++) {
      hour = padZero(i, 2);

      time.push({
        name: hour,
        value: hour,
        parent: 0
      });

      var ks = 0;
      var ke = 59;

      if (i === startHour) {
        ks = startMinute;
      }
      if (i === endHour) {
        ke = endMinute;
      }

      for (var j = ks; j <= ke; j++) {
        minute = padZero(j, 2);
        time.push({
          name: minute,
          value: hour + ':' + minute,
          parent: hour
        });
      }
    }

    return time
  },
  generateDateList: function generateDateList (start, end) {
    var this$1 = this;

    var years = [];
    var months = [];
    var days = [];

    var yearValues = [];
    var monthValues = [];

    var startDate = fecha.parse(start, 'YYYY-MM-DD');
    var endDate = fecha.parse(end, 'YYYY-MM-DD');

    var startTime = startDate.getTime();
    var diff = (endDate - startDate) / 86400000;

    var curDate, dayName, monthName, dayValue, dayParts, dayParentValue;

    for (var i = 0; i <= diff; i++) {
      curDate = new Date(startTime + 86400000 * i);
      dayName = padZero(curDate.getDate(), 2);
      monthName = padZero(curDate.getMonth() + 1, 2);

      dayParts = this$1.date2Arr(curDate);
      dayValue = dayParts.join('-');
      dayParentValue = dayParts[0] + '-' + dayParts[1];

      days.push({
        name: dayName,
        value: dayValue,
        parent: dayParentValue
      });

      if (monthValues.indexOf(dayParentValue) < 0) {
        monthValues.push(dayParentValue);
        months.push({
          name: monthName,
          value: dayParentValue,
          parent: dayParts[0]
        });

        if (yearValues.indexOf(dayParts[0]) < 0) {
          yearValues.push(dayParts[0]);
          years.push({
            name: dayParts[0],
            value: dayParts[0],
            parent: 0
          });
        }
      }
    }

    return [].concat(years, months, days)
  }
};

var timeValidator = function (val) {
  var parts = val.split(':').map(function (p) { return Number(p); });
  return parts.length === 2 && (parts[0] >= 0 && parts[0] < 24) && (parts[0] >= 0 && parts[0] < 60)
};
var timeSelector = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('picker',{attrs:{"title":_vm.title,"range":_vm.selfRange,"display-format":_vm.format,"columns":2,"disabled":_vm.disabled,"show-name":""},on:{"on-change":_vm.onChange,"cancel":_vm.handleChancel},model:{value:(_vm.selfValue),callback:function ($$v) {_vm.selfValue=$$v;},expression:"selfValue"}})},staticRenderFns: [],
  props: {
    range: {
      type: Array,
      default: Array
    },
    title: {
      type: String,
      default: '当前选择'
    },
    start: {
      type: String,
      validator: timeValidator,
      default: '00:00'
    },
    end: {
      type: String,
      validator: timeValidator,
      default: '23:59'
    },
    value: {
      type: String
    },
    disabled: Boolean
  },
  components: {
    picker: Picker
  },
  data: function data () {
    return {
      selfRange: this.getTime(),
      selfValue: this.getSelfValue(),
      lastChangeValue: '',
      format: function (value, name) {
        return value[1]
      }
    }
  },
  watch: {
    value: function value () {
      this.selfValue = this.getSelfValue();
    }
  },
  methods: {
    getTime: function getTime () {
      var time = util.generateTimeList(this.start, this.end);
      return time
    },
    getSelfValue: function getSelfValue () {
      return [this.value.split(':')[0], this.value]
    },
    getValue: function getValue (val) {
      return val
    },
    onChange: function onChange (val) {
      if (this.lastChangeValue !== val[1]) {
        this.$emit('change', val[1]);
        this.lastChangeValue = val[1];
      }
    },
    handleChancel: function handleChancel () {
      this.$emit('cancel');
    }
  }
};

var dateSelector = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('picker',{attrs:{"title":_vm.title,"range":_vm.selfRange,"columns":3,"disabled":_vm.disabled,"display-format":_vm.displayFormat,"show-name":""},on:{"on-change":_vm.onChange,"cancel":_vm.handleChancel},model:{value:(_vm.selfValue),callback:function ($$v) {_vm.selfValue=$$v;},expression:"selfValue"}})},staticRenderFns: [],
  props: {
    range: {
      type: Array,
      default: Array
    },
    title: {
      type: String,
      default: '当前选择'
    },
    value: String,
    chinese: Boolean,
    dateFormat: {
      type: String,
      default: 'YYYY-MM-DD'
    },
    start: {
      type: String,
      default: function () {
        return fecha.format(new Date(), 'YYYY-MM-DD')
      }
    },
    end: {
      type: String,
      default: function () {
        var date = new Date();
        return fecha.format(date.setFullYear(date.getFullYear() + 1), 'YYYY-MM-DD')
      }
    },
    disabled: Boolean
  },
  components: {
    picker: Picker
  },
  data: function data () {
    return {
      selfRange: [],
      selfValue: this.getSelfValue(),
      startYmd: [],
      endYmd: []
    }
  },
  watch: {
    value: function value () {
      this.selfValue = this.getSelfValue();
    }
  },
  mounted: function mounted () {
    this.selfRange = this.getDateList();
    if (this.start > this.end) {
      throw new Error('开始日期不能大于结束如期')
    }
  },
  methods: {
    getDateList: function getDateList () {
      return util.generateDateList(this.start, this.end)
    },
    getSelfValue: function getSelfValue () {
      var parts = this.value.split('-');
      var val = [parts[0], parts[0] + '-' + parts[1], parts[0] + '-' + parts[1] + '-' + parts[2]];
      return val
    },
    getValue: function getValue (val) {
      return val
    },
    displayFormat: function displayFormat (val) {
      var parts = val[2].split('-');
      var date = new Date(Number(parts[0]), Number(parts[1]) - 1, Number(parts[2]));
      return fecha.format(date, this.dateFormat)
    },
    onChange: function onChange (val) {
      this.$emit('change', val[2]);
    },
    handleChancel: function handleChancel () {
      this.$emit('cancel');
    }
  }
};

var regionSelector = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('picker',{attrs:{"fixed-columns":_vm.hideDistrict ? 2 : 0,"columns":3,"range":_vm.addressData,"range-key":_vm.rangeKey,"title":_vm.title,"show-name":"","disabled":_vm.disabled,"inline-desc":_vm.inlineDesc,"placeholder":_vm.placeholder,"value-text-align":_vm.valueTextAlign,"confirm-text":_vm.confirmText,"cancel-text":_vm.cancelText,"display-format":_vm.displayFormat},on:{"hide":_vm.emitHide,"show":function($event){_vm.$emit('show');},"on-change":_vm.onChange,"cancel":_vm.handleChancel},scopedSlots:_vm._u([{key:"title",fn:function(props){return [_vm._t("title",[(props.labelTitle)?_c('label',{class:props.labelClass,style:(props.labelStyle),domProps:{"innerHTML":_vm._s(props.labelTitle)}}):_vm._e()],{labelClass:props.labelClass,labelStyle:props.labelStyles,labelTitle:props.title})]}}]),model:{value:(_vm.currentValue),callback:function ($$v) {_vm.currentValue=$$v;},expression:"currentValue"}})},staticRenderFns: [],
  components: {
    Picker: Picker
  },
  props: {
    title: {
      type: String,
      required: true
    },
    range: {
      type: Array,
      default: Array
    },
    rangeKey: {
      type: String
    },
    value: {
      type: Array,
      default: function default$1$$1 () {
        return []
      }
    },
    rawValue: Boolean,
    inlineDesc: String,
    placeholder: String,
    hideDistrict: Boolean,
    valueTextAlign: String,
    confirmText: String,
    cancelText: String,
    displayFormat: {
      type: Function,
      default: function (val, names) { return names; }
    },
    disabled: Boolean
  },

  created: function created () {
    this.addressData = this.range;
    if (this.currentValue.length && this.rawValue) {
      var parsedVal = name2value(this.currentValue, this.list);
      if (/__/.test(parsedVal)) {
        console.error('TouchUI: Wrong address value', this.currentValue);
        this.currentValue = [];
      } else {
        this.currentValue = parsedVal.split(' ');
      }
    }
  },
  mounted: function mounted () {
  },
  methods: {
    emitHide: function emitHide (val) {
      this.$emit('hide', val);
    },
    getAddressName: function getAddressName () {
      return value2name(this.value, this.list)
    },
    onChange: function onChange (val) {
      this.$emit('change', val);
    },
    handleChancel: function handleChancel () {
      this.$emit('cancel');
    }
  },
  data: function data () {
    return {
      addressData: [],
      currentValue: this.value
    }
  },
  computed: {
    nameValue: function nameValue () {
      return value2name(this.currentValue, this.list)
    }
  },
  watch: {
    currentValue: function currentValue (val) {
      this.$emit('input', val);
    },
    value: function value (val) {
      if (val.length && !/\d+/.test(val[0])) {
        var id = name2value(val, this.list).split(' ');
        if (id[0] !== '__' && id[1] !== '__') {
          this.currentValue = id;
          return
        }
      }
      this.currentValue = val;
    }
  }
};

var index = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (_vm.mode ==='selector')?_c('selector',{attrs:{"range":_vm.selfRange,"range-key":_vm.rangeKey,"title":_vm.title,"value":_vm.value,"disabled":_vm.disabled},on:{"change":_vm.handleChange,"cancel":_vm.handleCancel}}):(_vm.mode ==='multiSelector')?_c('multi-selector',{attrs:{"range":_vm.selfRange,"range-key":_vm.rangeKey,"title":_vm.title,"is-chain":_vm.isChain,"value":_vm.value,"disabled":_vm.disabled},on:{"change":_vm.handleChange,"cancel":_vm.handleCancel}}):(_vm.mode ==='time')?_c('time-selector',{attrs:{"title":_vm.title,"value":_vm.value,"start":_vm.start,"end":_vm.end,"disabled":_vm.disabled},on:{"change":_vm.handleChange,"cancel":_vm.handleCancel}}):(_vm.mode ==='date')?_c('date-selector',{attrs:{"start":_vm.start,"end":_vm.end,"title":_vm.title,"value":_vm.value,"disabled":_vm.disabled,"date-format":_vm.dateFormat},on:{"change":_vm.handleChange,"cancel":_vm.handleCancel}}):(_vm.mode ==='region')?_c('region-selector',{attrs:{"title":_vm.title,"range":_vm.range,"range-key":_vm.rangeKey,"value":_vm.value,"hide-district":_vm.hideDistrict,"disabled":_vm.disabled},on:{"change":_vm.handleChange,"cancel":_vm.handleCancel}}):_vm._e()},staticRenderFns: [],
  props: {
    mode: {
      type: String,
      default: 'selector'
    },
    range: {
      type: Array,
      default: Array
    },
    rangeKey: {
      type: String
    },
    title: {
      type: String,
      default: '当前选择'
    },
    value: {
      type: [Number, String, Array]
    },
    dsiabled: {
      type: Boolean,
      default: false
    },
    hideDistrict: {
      type: Boolean,
      default: false
    },
    isChain: {
      type: Boolean,
      default: false
    },
    start: {
      type: String
    },
    end: {
      type: String
    },
    dateFormat: {
      type: String,
      default: 'YYYY-MM-DD'
    },
    disabled: Boolean
  },
  components: {
    selector: selector,
    multiSelector: multiSelector,
    timeSelector: timeSelector,
    dateSelector: dateSelector,
    regionSelector: regionSelector
  },
  data: function data () {
    return {
      selfRange: this.range
    }
  },
  watch: {
    range: function range () {
      this.selfRange = this.range;
    }
  },
  methods: {
    handleChange: function handleChange (val) {
      this.$emit('change', val);
    },
    handleCancel: function handleCancel () {
      this.$emit('cancel');
    }
  }
};

export default index;
